﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Shapes;
using System;
using NodePainter = BinaryTreeUI.NodePainter<BinaryTreeUI.TreeNode>;

namespace BinaryTreeUI
{
    /// <summary>
    /// Interaction logic for Demo.xaml
    /// </summary>
    public partial class Demo : Page
    {
        OrdinaryTree tree = new OrdinaryTree();
        public Demo()
        {
            InitializeComponent();
            this.ShowsNavigationUI = false;
            this.WindowTitle = "小明真牛X";
        }

        private void btnShow_Click(object sender, RoutedEventArgs e)
        {
            var array = new int[] { 16, 77, 6, 3, 255, 99, 17, 888, 45,33, 56 };

            foreach (var item in array)
            {
                this.tree.Insert(item);
            }
            canvas1.Children.Clear();
            var painter = new NodePainter();
            painter.Paint(tree.Root, canvas1);
        }

        private void btnAdd_Click(object sender, RoutedEventArgs e)
        {
            int value;
            if (!int.TryParse(txtValue.Text, out value))
            {
                MessageBox.Show("Please enter a valid integer.");
                return;
            }

            tree.Insert(value);
            PaintTree();
        }

        private void PaintTree()
        {
            canvas1.Children.Clear();
            var painter = new NodePainter();
            painter.Paint(tree.Root, canvas1);
        }

        private void btnRemove_Click(object sender, RoutedEventArgs e)
        {
            int value;
            if (!int.TryParse(txtValue.Text, out value))
            {
                MessageBox.Show("Please enter a valid integer.");
                return;
            }

            var success = this.tree.Remove(value);

            tbCue.Text = success ? (value + " is removed succesfully") : (value + " is not Found");
            if (success)
            {
                PaintTree();
            }
        }

        private void Page_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            
        }

    }

}
