﻿using System.Windows;
using System.Windows.Controls;
using NodePainter = BinaryTreeUI.NodePainter<BinaryTreeUI.RBTreeNode>;

namespace BinaryTreeUI
{
    /// <summary>
    /// Interaction logic for DemoRB.xaml
    /// </summary>
    public partial class DemoRB : Page
    {
        RBTree tree = new RBTree();
        public DemoRB()
        {
            InitializeComponent();
            this.ShowsNavigationUI = false;
        }

        private void btnAdd_Click(object sender, RoutedEventArgs e)
        {
            int value;
            if (!int.TryParse(txtValue.Text, out value))
            {
                MessageBox.Show("Please enter a valid integer.");
                return;
            }

            tree.Insert(value);
            PaintTree();
        }

        private void PaintTree()
        {
            canvas1.Children.Clear();
            var painter = new NodePainter();
            painter.Paint(tree.Root, canvas1);
        }

        private void btnRemove_Click(object sender, RoutedEventArgs e)
        {
            int value;
            if (!int.TryParse(txtValue.Text, out value))
            {
                MessageBox.Show("Please enter a valid integer.");
                return;
            }
            
            var success = this.tree.Remove(value);

            tbCue.Text = success ? (value + " is removed succesfully") : (value + " is not Found");
            if (success)
            {
                PaintTree();
            }
        }

        private void btnShow_Click(object sender, RoutedEventArgs e)
        {
            var array = new int[]{ 8, 18, 28, 38, 20, 55,66, 50,49,48,47,46,45,44,43,42,41 };
            //
            foreach (var item in array)
            {
                this.tree.Insert(item);
            }
            canvas1.Children.Clear();
            var painter = new NodePainter();
            painter.Paint(tree.Root, canvas1);
        }
    }
}
